//
//  ShaderView.m
//  CocoaShaders
//
//  Created by Guy English on 03/03/07.
//  Copyright 2007 __MyCompanyName__. All rights reserved.
//

#import "ShaderView.h"

#import "KBShader.h"

// this is a very simple custom view that uses a shader to draw its contents.
// ShaderView will also toggle its value on mouse up. the demo shader uses
// a predicate based on this views value to toggle between background colors.

@implementation ShaderView

- (void) dealloc
{
	[_shader release];
	[super dealloc];
}

- (void) setShader: (KBShader*) shader
{
	[shader retain];
	[_shader release];
	_shader = shader;
	[self setNeedsDisplay: YES];
}

- (KBShader*) shader
{
	return _shader;
}

- (void) drawRect: (NSRect) rect
{
	[_shader drawInRect: [self bounds] input: self];
}

- (void) mouseDown: (NSEvent*) event
{
	if ( [self value] == NO )
	{
		[self setValue: YES];
	}
	else
	{
		[self setValue: NO];
	}
}

- (void) setValue: (int) value
{
	_value = value;
	[self setNeedsDisplay: YES];
}

- (int) value
{
	return _value;
}

@end
